package env;
import java.util.*;

import node.*;
import node.declNode.*;
import type.*;

public class DeclList {

	private Vector< Decl > decls = new Vector< Decl >();
	
	public DeclList() {
		}
	
	public DeclList( Decl decl ) {
		addElement( decl );
		}
		
	public boolean equals( DeclList otherDeclList ) {
		if ( size() != otherDeclList.size() )
			return false;
		for ( int i = 0; i < size(); i++ ) {
			Decl decl = elementAt( i );
			Decl otherDecl = otherDeclList.elementAt( i );
			if ( ! decl.equals( otherDecl ) )
				return false;
			}
		return true;
		}
	
	public int size() {
		return decls.size();
		}

	public Decl elementAt( int i ) {
		return decls.elementAt( i );
		}
	
	public void addElement( Decl decl ) {
		decls.addElement( decl );
		}
			

	public void setElementAt( Decl decl, int index ) {
		if ( index >= size() )
			decls.setSize( index + 1 );
		decls.setElementAt( decl, index );
		}
			

	public Decl declare( 
		String ident, 
		int section, 
		DeclNode declNode, 
		Env env ) {
		Decl decl = new Decl( ident, section, declNode, env );
		decls.addElement( decl );
		return decl;
		}

	public Decl searchDeclList( String ident ) {
		for ( int i = 0; i < size(); i++ ) {
			Decl decl = elementAt( i );
			if ( decl.ident().equals( ident ) )
				return decl;
			}
		return null;
		}

	public DeclList paramDecls() {
		DeclList paramDecls = new DeclList();
		for ( int i = 0; i < size(); i++ ) {
			Decl decl = elementAt( i );
			switch ( decl.section() ) {
				case Decl.DECL_PARAM:
					paramDecls.addElement( decl );
				}
			}
		return paramDecls;
		}

	public String toString() {
		String result = "";
		for ( int i = 0; i < size(); i++ )
			result += "%n" + elementAt( i );
		return result;
		}

	}
