package node.declNode.declaratorNode;
import node.*;
import node.declNode.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import code.*;
import text.*;

public abstract class DeclaratorNode extends Node implements DeclNode {

	protected String ident;
	public String ident() { return ident; }
	private int section;
	protected Type type;
	protected Decl decl;
	public Decl decl() { return decl; }

	public DeclaratorNode( String ident ) {
		this.ident = ident;
		}

	public void genEnv( int section, Env env ) {
		this.section = section;
		super.genEnv( env );
		decl = env().declare( ident, section, this );
		}

	public void setType( Type type ) {
		this.type = type;
		decl.setType( type );
		}

	public abstract void checkType();

	public void genOffset() {
		decl.genOffset();
		}

	public abstract void eval( RunEnv runEnv ) throws ReturnException;

	public void genDeclCode() {
		decl.allocateSpace();
		}

	public abstract void genCode();

	}
