package node.declNode.declaratorNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public class InitDeclaratorNode extends DeclaratorNode {

	private ExprNode expr;

	public InitDeclaratorNode( String ident, ExprNode expr ) {
		super( ident );
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr;
		}

	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		expr.genEnv( env );
		}

	public void checkType() {
		Type exprType = expr.checkType();
		expr = expr.castTo( Type.CAST_IMPLICIT, type );
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		runEnv.elementAt( decl ).setValue( expr.eval( runEnv ) );
		}

	public void genCode() {
		expr.evalCode( null );
		Register sourceReg = expr.loadReg( expr.usage() );
		decl.store( sourceReg );
		}

	}
