package node.exprNode.binaryNode.arithNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class TimesNode extends ArithNode {

	public TimesNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "*";
		opCode = "mulq";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new IntValue( leftValue.intValue() * rightValue.intValue() );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( opCode, left.address(), right.address(), address() );
		}
	}
