package node.exprNode.binaryNode.relationNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class GreaterThanNode extends RelationNode {

	public GreaterThanNode( ExprNode left, ExprNode right ) {
		super( left, right );
		operator = ">";
		opCode = "cmple";
		}

	public Type checkType() {
		type = super.checkType();
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new BoolValue( leftValue.intValue() > rightValue.intValue() );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( "xor", address(), new Literal( 1 ), address() );
		}
		
	public void boolCode(
		Node sibling,
		Relative trueLabel, 
		Relative falseLabel, 
		boolean flowIntoTrue ) {
		super.evalCode( sibling );
		if ( flowIntoTrue ) {
			Code.instrn( "blbs", address(), falseLabel );
			}
		else {
			Code.instrn( "blbc", address(), trueLabel );
			}
		}

	}
