package node.exprNode.binaryNode.relationNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class RelationNode extends BinaryNode {

	public RelationNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		}

	public String toString() {
		return 
			left.toString( precedence + 1 ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		Type rightType = right.checkType();
		operandType = IntType.type;
		left = left.castTo( Type.CAST_IMPLICIT, operandType );
		right = right.castTo( Type.CAST_IMPLICIT, operandType );
		type = BoolType.type;
		return type;
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( opCode, left.address(), right.address(), address() );
		}
	}
