package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class NegateNode extends PrefixNode {

	public NegateNode( ExprNode right ) {
		super( right );
		operator = "-";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		if ( ! ( rightType instanceof IntType ) )
			throw new Error( "Non arithmetic type for negation" );
		operandType = rightType;
		type = rightType;
		opCode = "negq";
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new IntValue( - rightValue.intValue() );
		}

	public void evalCode( Node sibling ) {
		super.evalCode( sibling );
		Code.instrn( opCode, right.address(), address() );
		}
		
	}
