package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class PrefixVarNode extends ExprNode {

	protected VariableNode right;
	protected String operator;
	protected Type operandType;
	protected String opCode;

	public PrefixVarNode( VariableNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}

	public String toString() {
		return operator + " " + right;
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		right.genEnv( env );
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		right.evalAddrCode( sibling );
		}
	}
