package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import text.*;
import runEnv.*;
import code.*;

public class StringValueNode extends ValueNode {

	private String value;

	public StringValueNode( String value ) {
		this.value = value;
		}

	public String toString() {
		return "\"" + Convert.toFormatString( value ) + "\"";
		}

	public Type checkType() {
		type = new PtrType( CharType.type );
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new PtrValue( value );
		}

// Should improve with local naming

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		Code.enter();
		Code.enter( "const" );
		Code.align();
		Code.labelDefn( "string" );
		Code.asciiz( value );
		Code.exit( "const" );
		Register register = obtainReg( Usage.INTREG, usage() );
		Code.loadImm( type, register, "string" );
		Code.exit();
		setAddress( register );
		}

	}
