package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import code.*;
import text.*;

public class IdentVariableNode extends VariableNode {

	private String ident;
	private Decl decl;
	
	public IdentVariableNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public Type checkType() {
		decl = env().searchEnv( ident );
		if ( decl == null )
			throw new Error( "Undeclared Identifier " + ident );
		switch ( decl.section() ) {
			case Decl.DECL_VAR:
			case Decl.DECL_PARAM:
				type = decl.type();
				return type;
			default:
				throw new Error( ident + " must be variable or parameter" );
			}
		}

	public PtrValue evalAddr( RunEnv runEnv ) {
		return runEnv.elementAt( decl );
		}

	public void evalAddrCode( Node sibling ) {
		setSibling( sibling );
		setAddress( decl.address() );
		}
	}
