package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public abstract class VariableNode extends Node {
	protected Type type;
	protected Type addressType;
	public Type type() { return type; }
	public boolean addressable() { 
		if ( type instanceof ArrayType || type instanceof ClassInstanceType )
			return false;
		else
			return true;
		}

	public VariableNode() {
		}
		
	public abstract Type checkType();
	public abstract PtrValue evalAddr( RunEnv runEnv );
	public abstract void evalAddrCode( Node sibling );

	public Register saveReg( int dataType, Usage usage ) {
		if ( dataType != Usage.INTREG )
			return null;
		Address address = address();
		if ( address instanceof Displacement ) {
			Displacement displAddr = ( Displacement ) address;
			String offset = displAddr.offset();
			Address base = displAddr.base();
			if ( ! ( base instanceof IntTempReg ) )
				return null;
			Register register = ( Register ) base;
			usage.minus( register );
			Address tempMem = obtainTemp( usage );
			Code.store( type, register, tempMem );
			setAddress( new Displacement( offset, tempMem ) );
			return register;
			}
		return null;
		}
	
	}
