package node.typeNode;
import node.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ArrayTypeNode extends TypeNode {

	private int size;
	private TypeNode subTypeNode;

	public ArrayTypeNode( int size, TypeNode subTypeNode ) {
		this.size = size;
		this.subTypeNode = subTypeNode;
		}

	public String toString() {
		return "[" + size + " ]" + subTypeNode;
		}

	public void genEnv( Env env ) {
		subTypeNode.genEnv( env );
		}

	public Type getType() {
		Type subType = subTypeNode.getType();
		return new ArrayType( size, subType );
		}
		
	}
