package node.typeNode;
import node.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class PtrTypeNode extends TypeNode {

	private TypeNode subTypeNode;

	public PtrTypeNode( TypeNode subTypeNode ) {
		this.subTypeNode = subTypeNode;
		}

	public String toString() {
		return "^" + subTypeNode;
		}

	public void genEnv( Env env ) {
		subTypeNode.genEnv( env );
		}

	public Type getType() {
		Type subType = subTypeNode.getType();
		return new PtrType( subType );
		}
		
	}
