package node.typeNode;
import node.*;
import env.*;
import type.*;
import runEnv.*;

public class TypeIdentNode extends TypeNode {

	private String ident;
	
	public TypeIdentNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public Type getType() {
		Decl decl = env().searchEnv( ident );
		if ( decl == null )
			throw new Error( "Undeclared Identifier " + ident );
		if ( decl.section() != Decl.DECL_CLASS )
			throw new Error( ident + " must be class" );
		return decl.type().instanceType();
		}
	}
