package runEnv.basicValue;

import runEnv.*;
import text.*;

public class CharValue extends BasicValue {

	public final static CharValue defaultValue = new CharValue( '\0' );

	private char value;

	public CharValue( char value ) {
		this.value = value;
		}

	public int intValue() {
		return ( int ) value;
		}

	public char charValue() {
		return value;
		}

	public String toString() {
		return "\'" + Convert.toFormatString( value ) + "\'";
		}

	public String stringValue() {
		return "" + value;
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue.charValue() == value;
		}
	}
