package type;

import node.*;
import env.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public  class MethodType extends Type {

	private Type returnType;
	private DeclList formalDecls;
	public Type returnType() { return returnType; }
	public DeclList formalDecls() { return formalDecls; }

	public MethodType( Type returnType, DeclList formalDecls ) {
		this.returnType = returnType;
		this.formalDecls = formalDecls;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof MethodType ) )
			return false;
		MethodType methodType = ( MethodType ) type;
		return 
			methodType.returnType().equals( returnType )
			&& methodType.formalDecls().equals( formalDecls );
		}

	public String toString() {
		return returnType() + "(%+" + formalDecls() + " %-)";
		}

	public boolean isCastable( int castKind, Type type ) {
		return false;
		}

	public void initAddress( RunEnv runEnv, PtrValue address ) {
		}

	public void initAddressCode() {
		}
	}
