package type;

import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public class PtrType extends Type {

	private Type subType;
	public Type subType() { return subType; }
	
	public PtrType( Type subType ) {
		this.subType = subType;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof PtrType ) )
			return false;
		PtrType otherType = ( PtrType ) type;
		return subType().equals( otherType.subType() );
		}

	public boolean isCastable( int castKind, Type type ) {
		if ( type instanceof NullType )
			return true;
		else if ( equals( type ) )
			return true;
		else if ( type instanceof PtrType )  {
			PtrType ptrType = ( PtrType ) type;
			return subType.isCastable( castKind, ptrType.subType() );
			}
		else
			return false;
		}

	public String toString() {
		return "^" + subType;
		}
	
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( NullValue.defaultValue );
		}

	}
