package type;

import env.*;
import runEnv.*;
import runEnv.basicValue.*;
import code.*;

public abstract class Type {

	public final static int CAST_EXPLICIT	=	1;
	public final static int CAST_IMPLICIT	=	2;
	public final static int CAST_PARAM		=	3;
	public final static int WORD			=	8;

	public static Type balanceType( Type type1, Type type2 ) {
		if ( type1.isCastable( CAST_IMPLICIT, type2 ) )
			return type1;
		if ( type2.isCastable( CAST_IMPLICIT, type1 ) )
			return type2;
		else
			return null;
		}
		
	public abstract boolean equals( Type type );
	public abstract String toString();

	public Type instanceType() {
		return this;
		}

	public Type formalType() {
		return this;
		}

	public Type primitiveType() {
		return this;
		}

	public int numPrimitiveElements() { return 1; }

	public boolean isCastable( int castKind, Type type ) {
		return equals( type );
		}

	public Offset size() {
		return new Offset( 1, WORD );
		}

	public abstract void initAddress( RunEnv runEnv, PtrValue address )
		throws ReturnException;

	public void initAddressCode() {
		Code.store( this, SpecialReg.zero, 
			new Indirect( SpecialReg.newInstPtr ) );
		}
	}
