import java.io.*;
import java_cup.runtime.*;
import grammar.*;
import node.Node;

public class Main {

	public static void main( String[] argv ) {
		String dirName = null;

		try {
			for ( int i = 0; i < argv.length; i++ ) {
				if ( argv[ i ].equals( "-dir" ) ) {
					i++;
					if ( i >= argv.length )
						throw new Error( "Missing directory name" );
					dirName = argv[ i ];
					}
				else {
					throw new Error( 
						"Usage: java Main -dir directory" );
					}
				}

			if ( dirName == null )
				throw new Error( "Directory not specified" );

			System.setErr( new PrintStream( new FileOutputStream( 
				new File( dirName, "program.err" ) ) ) );
			System.setOut( new PrintStream( new FileOutputStream( 
				new File( dirName, "program.out" ) ) ) );

			parser p = new parser( new File( dirName, "program.in" ) );
			Node node = ( Node ) ( p.parse().value );
			if ( node != null )
				node.print( 0 );
			}
		catch ( Exception e ) {
			System.err.println( "Exception" );
			}
		}
	}

