import java.io.*;
import java_cup.runtime.*;
import grammar.*;
import node.exprNode.*;

public class Main {

	public static void main( String[] argv ) {
		try {
			if ( argv.length != 2 )
				throw new Error( "Usage: java Main pattern filename" );
			// System.out.println( "argv[ 0 ] = " + argv[ 0 ] );
			// System.out.println( "argv[ 1 ] = " + argv[ 1 ] );
			parser p = new parser( argv[ 0 ] );

			ExprNode exprNode = ( ExprNode ) ( p.parse().value );
			System.err.println( "Parse tree " + exprNode );

			if ( exprNode != null ) {
				int line = 1;
				String buffer;
				BufferedReader inputStream = 
					new BufferedReader( 
						new InputStreamReader( 
							new FileInputStream( argv[ 1 ] ) ) );
	
				while ( ( buffer = inputStream.readLine() ) != null ) {
					if ( exprNode.match( buffer ) )
						System.out.println( line+ ": " + buffer );
					line++;
					}
				}
			else
				System.out.println( "Null parse tree" );
			}
		catch ( Exception e ) {
			System.out.println( e.getMessage() );
			}
		}

	}

