package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class IfThenElseStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode stmt1;
	private StmtNode stmt2;

	public IfThenElseStmtNode( 
		ExprNode cond, 
		StmtNode stmt1, 
		StmtNode stmt2 ) {
		this.cond = cond;
		this.stmt1 = stmt1;
		this.stmt2 = stmt2;
		}

	public String toString() {
		return "if " + cond + " then%+%n" 
			+ stmt1 + "%-else%+%n" + stmt2 + "%-";
		}

	public void eval( RunEnv runEnv ) {
		if ( Cast.booleanValue( cond.eval( runEnv ) ) )
			stmt1.eval( runEnv );
		else
			stmt2.eval( runEnv );
		}
		
	}
