package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class AssignStmtNode extends StmtNode {

	private String ident;
	private ExprNode expr;
	
	public String ident() { return ident; }
	public ExprNode expr() { return expr; }

	public AssignStmtNode( String ident, ExprNode expr ) {
		this.ident = ident;
		this.expr = expr;
		}
	
	public String toString() {
		return ident + " = " + expr + ";";
		}
		
	public void eval( RunEnv runEnv ) {
		Object value = expr.eval( runEnv );
		runEnv.locals().put( ident, value );
		}
		
	}
