package node;

import runEnv.*;
import node.declNode.*;
import node.stmtNode.*;

import java.util.*;

public class ProgramNode extends Node {

	private DeclNode decl;
	private StmtListNode stmtList;

	public ProgramNode( DeclNode decl, StmtListNode stmtList ) {
		this.decl = decl;
		this.stmtList = stmtList;
		}

	public String toString() {
		return "program%+" + decl + "%nbegin%+%n" + stmtList + "%-%nend.%-%n";
		}
		
	public void eval() throws ReturnException {
		Hashtable< String, Object > hashtable = new Hashtable< String, Object >();
		RunEnv runEnv = new RunEnv( hashtable, null );
		decl.eval( hashtable, runEnv );
		stmtList.eval( runEnv );
		}
	}
