package node.declNode.declaratorNode;
import runEnv.*;
import node.exprNode.*;
import java.util.*;

public class InitDeclaratorNode extends DeclaratorNode {

	private String ident;
	private ExprNode expr;

	public InitDeclaratorNode( String ident, ExprNode expr ) {
		this.ident = ident;
		this.expr = expr;
		}

	public String toString() {
		return ident + " = " + expr;
		}

	public void eval( Hashtable< String, Object > localDecls, RunEnv runEnv ) {
		Object exprValue = expr.eval( runEnv );
		if ( localDecls.get( ident ) != null )
			error( ident + " redeclared" );
		localDecls.put( ident, exprValue );
		}
	}
