package node.exprNode;
import runEnv.*;
import node.exprNode.variableNode.*;

public class AssignNode extends ExprNode {

	private VariableNode variable;
	private ExprNode expr;
	
	public AssignNode( VariableNode variable, ExprNode expr ) {
		this.variable = variable;
		this.expr = expr;
		precedence = PREC_ASSIGN;
		}
	
	public String toString() {
		return variable + " = " + expr;
		}
		
	public Object eval( RunEnv runEnv ) {
		Object value = expr.eval( runEnv );
		variable.eval( runEnv ).set( value );
		return value;
		}
		
	}
