package node.exprNode.binaryNode.relationNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class NotEqualNode extends RelationNode {

	public NotEqualNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		operator = "!=";
		}

	public Object eval( RunEnv runEnv ) {
		Object leftValue = left.eval( runEnv );
		Object rightValue = right.eval( runEnv );
		if ( leftValue instanceof NullValue && rightValue instanceof NullValue )
			return new Boolean( false );
		else if ( leftValue instanceof NullValue || rightValue instanceof NullValue )
			return new Boolean( true );
		else
			return new Boolean( ! leftValue.equals( rightValue ) );
		}
		
	}
