package node.exprNode.prefixNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class SizeNode extends PrefixNode {

	public SizeNode( ExprNode right ) {
		super( right );
		operator = "size";
		}

	public Object eval( RunEnv runEnv ) {
		Object value = right.eval( runEnv );
		if ( value instanceof String ) {
			String stringValue = ( String ) value;
			return new Integer( stringValue.length() );
			}
		else if ( value instanceof Vector ) {
			Vector arrayValue = ( Vector ) value;
			return new Integer( arrayValue.size() );
			}
		else
			error( "Invalid operand for size" );
		return null;
		}
		
	}
