package node.exprNode.variableNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class SubscriptVariableNode extends VariableNode {

	private ExprNode array;
	private ExprNode subscript;
	
	public SubscriptVariableNode( ExprNode array, ExprNode subscript ) {
		this.array = array;
		this.subscript = subscript;
		}

	public VariableValue eval( RunEnv runEnv ) {
		Vector< Object > arrayValue = Cast.arrayValue( array.eval( runEnv ) );
		int subscriptValue = Cast.intValue( subscript.eval( runEnv ) );
		if ( subscriptValue < 0 || subscriptValue >= arrayValue.size() )
			error( "Subscript out of bounds" );
		return new SubscriptVariableValue( arrayValue, subscriptValue );
		}

	public String toString() {
		return array.toString( ExprNode.PREC_PRIMARY ) + "[ " + subscript + " ]";
		}
	}
