package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class ElseOpt2Node extends ElseOptNode {

	private ExprNode cond;
	private StmtListNode thenPart;
	private ElseOptNode elseOpt;

	public ElseOpt2Node( 
		ExprNode cond,
		StmtListNode thenPart,
		ElseOptNode elseOpt ) {
		this.cond = cond;
		this.thenPart = thenPart;
		this.elseOpt = elseOpt;
		}

	public String toString() {
		return "%nelif " + cond + " then%+%n" + thenPart + "%-" + elseOpt;
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		if ( Cast.booleanValue( cond.eval( runEnv ) ) )
			thenPart.eval( runEnv );
		else 
			elseOpt.eval( runEnv );
		}
	}
