package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class WhileStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtListNode stmtList;

	public WhileStmtNode( ExprNode cond, StmtListNode stmtList ) {
		this.cond = cond;
		this.stmtList = stmtList;
		}

	public String toString() {
		return "while " + cond + " do%+%n" + stmtList + "%-%nend";
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		while ( Cast.booleanValue( cond.eval( runEnv ) ) )
			stmtList.eval( runEnv );
		}
		
	}
