package runEnv;
import java.util.*;

public class RunEnv {

	private Hashtable< String, Object > locals;
	private RunEnv globals;
	
	public Hashtable< String, Object > locals() { return locals; }
	public RunEnv globals() { return globals; }

	public RunEnv( 
		Hashtable< String, Object > locals,
		RunEnv globals ) {
		this.locals = locals;
		this.globals = globals;
		}
	
	public RunEnv() {
		this( new Hashtable< String, Object >(), null );
		}
	
	public Hashtable< String, Object > locals( String ident ) {
		Object value;
		value = locals.get( ident );
		if ( value != null )
			return locals;
		if ( globals != null )
			return globals.locals( ident );
		else
			throw new Error( "Undeclared identifier " + ident );
		}

	public Object search( String ident ) {
		Object value;
		value = locals.get( ident );
		if ( value != null )
			return value;
		if ( globals != null )
			return globals.search( ident );
		else
			throw new Error( "Undeclared identifier " + ident );
		}
	}
