package env;

import type.*;

public class Block {

	private Type returnType;
	private DeclList formalDecls = new DeclList();
	private DeclList typeDecls = new DeclList();
	private DeclList varDecls = new DeclList();
	private DeclList functDecls = new DeclList();
	
	public Type returnType() { 
		if ( returnType == null )
			return null;
		else
			return returnType.nonRefType(); 
		}
	public DeclList formalDecls() { return formalDecls; }
	public DeclList typeDecls() { return typeDecls; }
	public DeclList varDecls() { return varDecls; }
	public DeclList functDecls() { return functDecls; }
	
	public Block() {
		}
	
	public void setReturnType( Type returnType ) {
		this.returnType = returnType.nonRefType();
		}

	public void setAddress( int level ) {
		formalDecls.setLevel( level );
		typeDecls.setLevel( level );
		varDecls.setLevel( level );
		functDecls.setLevel( level );
		formalDecls.setOffset( 0 );
		varDecls.setOffset( formalDecls.size() );
		}

	public Decl search( String ident ) {
		Decl decl = null;
		decl = formalDecls.search( ident );
		if ( decl != null )
			return decl;
		decl = typeDecls.search( ident );
		if ( decl != null )
			return decl;
		decl = varDecls.search( ident );
		if ( decl != null )
			return decl;
		decl = functDecls.search( ident );
		if ( decl != null )
			return decl;
		return null;
		}

	public String toString() {
		return
			"formalDecls:%+" + formalDecls + "%-%n"
			+ "typeDecls:%+" + typeDecls + "%-%n"
			+ "varDecls:%+" + varDecls + "%-%n"
			+ "functDecls:%+" + functDecls + "%-%n"
			+ "returnType:%+" + returnType + "%-%n";
		}

	}
