package node.declNode;
import env.*;
import runEnv.*;
import node.*;
import node.stmtNode.*;

public class BlockNode extends Node {

	private DeclListNode locals;
	private StmtListNode stmtList;
	private Block block;

	public BlockNode( DeclListNode locals, StmtListNode stmtList ) {
		this.locals = locals;
		this.stmtList = stmtList;
		}

	protected BlockNode() {
		}

	public String toString() {
		if ( locals.size() == 0 )
			return "begin%+%n" + stmtList + "%-%nend";
		else
			return locals + "%nbegin%+%n" + stmtList + "%-%nend";
		}
		
	public void checkType( Env env ) {
		block = env.block();
		locals.checkType( block, env );
		block.setAddress( env.level() );
		//	Print.error().println( env );
		stmtList.checkType( env );
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		int size = block.varDecls().size();
		runEnv.locals().addData( size );
		stmtList.eval( runEnv );
		}
	}
