package node.declNode;
import env.*;
import type.*;
import runEnv.*;
import node.typeNode.*;

public class FieldDeclNode extends DeclNode {

	private IdentListNode identList;
	private TypeNode typeNode;

	public FieldDeclNode( IdentListNode identList, TypeNode typeNode ) {
		this.identList = identList;
		this.typeNode = typeNode;
		}

	public String toString() {
		return identList + " : " + typeNode + ";";
		}

	public void checkType( Block localBlock, Env env ) {
		DeclList fieldDecls = localBlock.varDecls();
		Type type = typeNode.getType( env );
		for ( int i = 0; i < identList.size(); i++ ) {
			String ident = identList.elementAt( i );
			if ( localBlock.search( ident ) != null )
				error( "Redeclared field " + ident );
			Decl decl = fieldDecls.declare( ident, Decl.FIELD, type );
			}
		}

	}
