package node.declNode;
import env.*;
import type.*;
import runEnv.*;
import node.typeNode.*;

public class FunctionDeclNode extends DeclNode {

	private String ident;
	private DeclListNode formalParams;
	private TypeNode returnType;
	private BlockNode body;
	private Decl decl;
	
	public FunctionDeclNode( 
		String ident,
		DeclListNode formalParams,
		TypeNode returnType,
		BlockNode body ) {
		this.ident = ident;
		this.formalParams = formalParams;
		this.returnType = returnType;
		this.body = body;
		}
	
	public String toString() {
		return "funct " + ident + "(%+%n" + formalParams + "%n) " + returnType + "%n" + body + "%-";
		}
		
	public void checkType( Block block, Env env ) {
		if ( block.search( ident ) != null )
			error( "Redeclared function " + ident );
		Block localBlock = new Block();
		formalParams.checkType( localBlock, env );
		localBlock.setReturnType( returnType.getType( env ) );
		Type functType = new FunctType( localBlock );
		decl = block.functDecls().declare( ident, Decl.FUNCT, functType );
		decl.setBody( body );
		Env localEnv = new Env( localBlock, env );
		body.checkType( localEnv );
		}
		
	}
