package node.declNode;
import env.*;
import type.*;
import runEnv.*;
import node.typeNode.*;

public class TypeDeclNode extends DeclNode {

	private String ident;
	private TypeNode typeNode;

	public TypeDeclNode( String ident, TypeNode typeNode ) {
		this.ident = ident;
		this.typeNode = typeNode;
		}

	public String toString() {
		return "type " + ident + " = " + typeNode + ";";
		}

	public void checkType( Block localBlock, Env env ) {
		if ( localBlock.search( ident ) != null )
			error( "Redeclared type " + ident );
		Decl decl = localBlock.typeDecls().declare( ident, Decl.TYPE, null );
		Type type = typeNode.getType( env );
		if ( type instanceof RefType ) {
			decl.setType( ErrorType.type );
			error( "Type " + ident + " defined as itself" );
			}
		decl.setType( type );
		}

	}
