package node.declNode;
import env.*;
import type.*;
import runEnv.*;
import node.typeNode.*;

public class VarParamDeclNode extends DeclNode {

	private IdentListNode identList;
	private TypeNode typeNode;

	public VarParamDeclNode( IdentListNode identList, TypeNode typeNode ) {
		this.identList = identList;
		this.typeNode = typeNode;
		}

	public String toString() {
		return "var " + identList + " : " + typeNode + ";";
		}

	public void checkType( Block localBlock, Env env ) {
		DeclList formalDecls = localBlock.formalDecls();
		Type type = typeNode.getType( env );
		for ( int i = 0; i < identList.size(); i++ ) {
			String ident = identList.elementAt( i );
			if ( localBlock.search( ident ) != null )
				error( "Redeclared formal parameter " + ident );
			Decl decl = formalDecls.declare( ident, Decl.VARPARAM, type );
			}
		}

	}
