package node.exprNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.variableNode.*;

public class AssignNode extends ExprNode {

	private VariableNode variable;
	private ExprNode expr;
	
	public AssignNode( VariableNode variable, ExprNode expr ) {
		this.variable = variable;
		this.expr = expr;
		precedence = PREC_ASSIGN;
		}
	
	public String toString() {
		return variable + " = " + expr;
		}

	public Type checkType( Env env ) {
		type = variable.checkType( env );
		Type exprType = expr.checkType( env );
		expr = expr.castTo( type );
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunData address = variable.eval( runEnv );
		RunValue value = expr.eval( runEnv );
		address.setValue( value );
		return value;
		}
	}
