package node.exprNode.binaryNode.arithNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;

public abstract class ArithNode extends BinaryNode {

	public ArithNode( ExprNode left, ExprNode right ) {
		super( left, right );
		}

	public Type checkType( Env env ) {
		Type leftType = left.checkType( env );
		Type rightType = right.checkType( env );
		Type operandType = Type.balanceType( leftType, rightType );
		if ( operandType == null )
			error( "Incompatible operand types of " + leftType + 
				" and " + rightType + " for =" );
		left = left.castTo( operandType );
		right = right.castTo( operandType );
		type = operandType;
		return type;
		}

	}
