package node.exprNode.binaryNode.boolNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class AndNode extends BoolNode {

	public AndNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_AND;
		operator = "and";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new RunValue( leftValue.boolValue() && rightValue.boolValue() );
		}
	}
