package node.exprNode.binaryNode.boolNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class OrNode extends BoolNode {

	public OrNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_OR;
		operator = "or";
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		return new RunValue( leftValue.boolValue() || rightValue.boolValue() );
		}
	}
