package node.exprNode.binaryNode.relationNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;

public abstract class RelationNode extends BinaryNode {

	protected Type operandType;

	public RelationNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		}

	public String toString() {
		return 
			left.toString( precedence + 1 ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public Type checkType( Env env ) {
		Type leftType = left.checkType( env );
		Type rightType = right.checkType( env );
		operandType = Type.balanceType( leftType, rightType );
		if ( operandType == null )
			error( "Incompatible operand types of " + leftType + 
				" and " + rightType + " for relation" );
		//	Print.error().println( "leftType = " + leftType );
		//	Print.error().println( "rightType = " + rightType );
		//	Print.error().println( "operandType = " + operandType );
		left = left.castTo( operandType );
		right = right.castTo( operandType );
		type = BoolType.type;
		return type;
		}

	}
