package node.exprNode.prefixNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class NotNode extends PrefixNode {

	public NotNode( ExprNode right ) {
		super( right );
		operator = "not";
		}

	public Type checkType( Env env ) {
		Type rightType = right.checkType( env );
		type = BoolType.type;
		right = right.castTo( type );
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new RunValue( ! rightValue.boolValue() );
		}
	}
