package node.exprNode.prefixNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class SizeNode extends PrefixNode {

	public SizeNode( ExprNode right ) {
		super( right );
		operator = "size";
		}

	public Type checkType( Env env ) {
		Type rightType = right.checkType( env );
		if ( ! ( rightType instanceof ArrayType ) )
			error( "Operand of size operator must be an array" );
		type = IntType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new RunValue( rightValue.multipleValue().size() );
		}
	}
