package node.exprNode.primaryNode;
import env.*;
import node.exprNode.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class OrdNode extends PrimaryNode {

	private ExprNode expr;
	
	public OrdNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "ord( " + expr + " )";
		}
		
	public Type checkType( Env env ) {
		Type exprType = expr.checkType( env );
		expr = expr.castTo( CharType.type );
		type = IntType.type;
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue value = expr.eval( runEnv );
		return new RunValue( ( int ) value.charValue() );
		}
	}
