package node.exprNode.variableNode;
import env.*;
import type.*;
import runEnv.*;
import node.exprNode.*;

public class FieldVariableNode extends VariableNode {

	private ExprNode structure;
	private String ident;
	private Decl fieldDecl;	

	public FieldVariableNode( ExprNode structure, String ident ) {
		this.structure = structure;
		this.ident = ident;
		}

	public Type checkType( Env env ) {
		Type sType = structure.checkType( env );
		if ( ! ( sType instanceof StructType ) )
			error( "Attempting to select a non-structure" );
		StructType structType = ( StructType ) sType;
		fieldDecl = structType.fieldDecls().search( ident );
		if ( fieldDecl == null )
			error( "Undeclared field " + ident );
		type = fieldDecl.type();
		return type;
		}

	public String toString() {
		return structure.toString( ExprNode.PREC_PRIMARY ) + "." + ident;
		}

	public RunData eval( RunEnv runEnv ) {
		RunValue structValue = structure.eval( runEnv );
		int offset = fieldDecl.offset();
		return structValue.multipleValue().getData( offset );
		}
	}
