package node.stmtNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import node.exprNode.*;

public class DoStmtNode extends StmtNode {

	private StmtListNode stmtList;
	private ExprNode cond;

	public DoStmtNode( StmtListNode stmtList, ExprNode cond ) {
		this.stmtList = stmtList;
		this.cond = cond;
		}

	public String toString() {
		return "do%+%n" + stmtList + "%-%nend%nwhile " + cond + ";";
		}

	public void checkType( Env env ) {
		stmtList.checkType( env );
		Type condType = cond.checkType( env );
		cond = cond.castTo( BoolType.type );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		do
			stmtList.eval( runEnv );
		while ( cond.eval( runEnv ).boolValue() );
		}

	}
