package node.typeNode;
import env.*;
import type.*;
import runEnv.*;

public class TypeIdentNode extends TypeNode {

	private String ident;
	
	public TypeIdentNode( String ident ) {
		this.ident = ident;
		}

	public Type getType( Env env ) {
		Decl decl = env.search( ident );
		if ( decl == null )
			error( "Undeclared Type " + ident );
		if ( decl.kind() != Decl.TYPE )
			error( "Identifier " + ident + " not declared as type" );
		Type type = decl.type();
		if ( type == null )
			return new RefType( decl );
		else
			return decl.type();
		}

	public String toString() {
		return ident;
		}
	}
