package type;

import type.basicType.*;

public abstract class Type {

	public static Type balanceType( Type type1, Type type2 ) {
		if ( type1 instanceof IntType && type2 instanceof IntType )
			return type2;
		else if ( type1 instanceof RealType && type2 instanceof RealType )
			return type2;
		else if ( type1 instanceof IntType && type2 instanceof RealType )
			return type2;
		else if ( type1 instanceof RealType && type2 instanceof IntType )
			return type1;
		return null;
		}
		
	public Type nonRefType() {
		return this;
		}

	public static boolean isCastable( Type preType, Type postType ) {
		return
			postType instanceof VoidType
			|| preType instanceof IntType && postType instanceof RealType
			|| preType instanceof NullType 
				&& ( postType instanceof ArrayType || postType instanceof StructType )
			|| ! ( preType instanceof VoidType ) && postType instanceof StringType;
		}

	public abstract boolean equals( Type type );
	public abstract String toString();

	}
