package node;
import env.*;
import runEnv.*;
import text.*;
import java.util.*;
import node.stmtNode.*;

public class DeclStmtListNode extends ListNode< DeclStmtNode > {

	public DeclStmtListNode() {
		super( "%n" );
		}
	
	public DeclStmtListNode( DeclStmtNode node ) {
		this();
		addElement( node );
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclStmtNode declStmt = elementAt( i );
				declStmt.genEnv( env );
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorStmtNode() );
				}
			}
		}

	public void setType() {
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclStmtNode declStmt = elementAt( i );
				declStmt.setType();
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorStmtNode() );
				}
			}
		}

	public void checkType() {
		for ( int i = 0; i < size(); i++ ) {
			try {
				DeclStmtNode declStmt = elementAt( i );
				declStmt.checkType();
				}
			catch ( Error exception ) {
				Print.error().println( exception.getMessage() );
				setElementAt( i, new ErrorStmtNode() );
				}
			}
		}

	public void eval( RunEnv runEnv ) throws UserException {
		for ( int i = 0; i < size(); i++ ) {
			DeclStmtNode declStmt = elementAt( i );
			declStmt.eval( runEnv );
			}
		}

	}

