package node.declNode;
import node.*;
import node.typeNode.*;
import node.declNode.declaratorNode.*;
import env.*;
import type.*;
import runEnv.*;

public class VariableDeclNode extends DeclStmtNode implements DeclNode {

	private TypeNode typeNode;
	private DeclaratorListNode declrList;

	private Type type;

	public VariableDeclNode( TypeNode typeNode, DeclaratorListNode declrList ) {
		this.typeNode = typeNode;
		this.declrList = declrList;
		}

	public String toString() {
		return typeNode + " " + declrList + ";";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		typeNode.genEnv( env );
		declrList.genEnv( Decl.SECT_VARIABLE, env );
		}

	public void setType() {
		type = typeNode.getType();
		declrList.setType( type );
		}

	public void checkType() {
		declrList.checkType();
		}

	public void eval( RunEnv runEnv ) {
		declrList.eval( runEnv );
		}

	}
