package node.exprNode.binaryNode.relationNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class RelationNode extends BinaryNode {

	protected Type operandType;

	public RelationNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		}

	public String toString() {
		return 
			left.toString( precedence + 1 ) 
			+ " " +  operator + " " 
			+ right.toString( precedence + 1 );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		Type rightType = right.checkType();
		operandType = Type.arithBalanceType( leftType, rightType );
		if ( operandType == null )
			error( "Incompatible operand types of " + leftType + 
				" and " + rightType + " for relation" );
		left = left.castTo( operandType );
		right = right.castTo( operandType );
		type = BoolType.type;
		return type;
		}

	}
