package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class NegateNode extends PrefixNode {

	public NegateNode( ExprNode right ) {
		super( right );
		operator = "-";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		if ( ! ( rightType instanceof IntType ) 
			&& ! ( rightType instanceof RealType ) )
			error( "Non arithmetic type for negation" );
		operandType = rightType;
		type = rightType;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		if ( type instanceof IntType )
			return new IntValue( - rightValue.intValue() );
		else if ( type instanceof RealType )
			return new RealValue( - rightValue.realValue() );
		error( "Invalid Type for - of " + type );
		return null;
		}
	}
