package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class PrefixNode extends ExprNode {

	protected String operator;
	protected Type operandType;
	protected ExprNode right;

	public PrefixNode( ExprNode right ) {
		this.right = right;
		precedence = PREC_PREFIX;
		}
		
	public String toString() {
		return operator + " " + right.toString( precedence );
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		right.genEnv( env );
		}

	}
