package node.exprNode.prefixNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class SizeNode extends PrefixNode {

	public SizeNode( ExprNode right ) {
		super( right );
		operator = "size";
		}

	public Type checkType() {
		Type rightType = right.checkType();
		if ( ! ( rightType instanceof ArrayType ) )
			error( "Operand of size operator must be an array" );
		operandType = rightType;
		type = IntType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		RunValue rightValue = right.eval( runEnv );
		return new IntValue( rightValue.arrayValue().size() );
		}

	}
