package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ExprStmtNode extends StmtNode {

	private ExprNode expr;
	
	public ExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "" + expr + ";";
		}
		
	public void genEnv( Env env ) {
		super.genEnv( env );
		expr.genEnv( env );
		}

	public void setType() {
		}

	public void checkType() {
		Type type = expr.checkType();
		expr = expr.castTo( VoidType.type );
		}

	public void eval( RunEnv runEnv ) {
		expr.eval( runEnv );
		}

	}
