package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class LabelledStmtNode extends StmtNode {

	private String ident;
	private StmtNode stmt;
	private Env localEnv;
	private Decl decl;

	public LabelledStmtNode( String ident, StmtNode stmt ) {
		this.ident = ident;
		this.stmt = stmt;
		}

	public String toString() {
		return ident + ":%n%+" + stmt + "%-";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		localEnv = new Env( Env.ENV_LABEL, env );
		decl = localEnv.declare( ident, Decl.SECT_LABEL, null );
		stmt.genEnv( localEnv );
		}

	public void setType() {
		stmt.setType();
		}

	public void checkType() {
		stmt.checkType();
		}
		
	public void eval( RunEnv runEnv ) throws UserException {
		Multiple locals = new Multiple( 0 );
		RunEnv localRunEnv = new RunEnv( locals, runEnv );
		try {
			stmt.eval( localRunEnv );
			}
		catch ( ExitException exception ) {
			if ( exception.decl() != decl )
				throw exception;
			}
		}

	}
