package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class WhileStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode stmt;

	public WhileStmtNode( ExprNode cond, StmtNode stmt ) {
		this.cond = cond;
		this.stmt = stmt;
		}

	public String toString() {
		return "while ( " + cond + ")%+%n" + stmt + "%-";
		}

	public void genEnv( Env env ) {
		super.genEnv( env );
		cond.genEnv( env );
		stmt.genEnv( env );
		}

	public void setType() {
		stmt.setType();
		}

	public void checkType() {
		Type condType = cond.checkType();
		cond = cond.castTo( BoolType.type );
		stmt.checkType();
		}
		
	public void eval( RunEnv runEnv ) throws UserException {
		try {
			while ( cond.eval( runEnv ).boolValue() )
				try {
					stmt.eval( runEnv );
					}
				catch ( ContinueException exception ) {
					}
			}
		catch ( BreakException exception ) {
			}
		}

	}
