package type;

import type.basicType.*;

public  class ArrayType extends Type {

	private Type subType;
	public Type subType() { return subType; }
	
	public ArrayType( Type subType ) {
		this.subType = subType;
		}
	
	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		if ( ! ( type instanceof ArrayType ) )
			return false;
		ArrayType otherType = ( ArrayType ) type;
		return subType().equals( otherType.subType() );
		}

	public boolean isCastable( Type type ) {
		return equals( type ) || type instanceof NullType;
		}

	public String toString() {
		return "[]" + subType;
		}
		
	}
