package type;
import env.*;
import type.basicType.*;

public  class ClassInstanceType extends Type {

	private String ident;
	private Env env;

	public String ident() { return ident; }
	public Env env() { return env; }
	public DeclList fieldDecls() { return env.localDecls(); }

	public ClassInstanceType( String ident, Env env ) {
		this.ident = ident;
		this.env = env;
		}
	
	public boolean equals( Type type ) {
		if ( type == this )
			return true;
		if ( ! ( type instanceof ClassInstanceType ) )
			return false;
		ClassInstanceType classInstanceType = ( ClassInstanceType ) type;
		return classInstanceType.ident().equals( ident );
		}

	public boolean isCastable( Type type ) {
		return equals( type ) || type instanceof NullType;
		}

	public String toString() {
		return "instance " + ident;
		}

	}
