package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class VoidType extends BasicType {

	public final static VoidType type = new VoidType();

	public VoidType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof VoidType;
		}

	public boolean isCastable( Type type ) {
		return true;
		}

	public String toString() {
		return "void";
		}
		
	public RunValue defaultValue() {
		return new VoidValue();
		}

	}
