package env;
import java.util.*;

import node.*;
import node.declNode.*;
import type.*;
import template.*;

public class DeclList {

	private Vector< Decl > decls = new Vector< Decl >();
	
	public DeclList() {
		}
	
	public int size() {
		return decls.size();
		}

	public Decl elementAt( int i ) {
		return ( Decl ) decls.elementAt( i );
		}
	
	public void addElement( Decl decl ) {
		decls.addElement( decl );
		}
			

	public void setElementAt( Decl decl, int index ) {
		if ( index >= size() )
			decls.setSize( index + 1 );
		decls.setElementAt( decl, index );
		}
			

	public Decl declare( 
		String ident, 
		int section, 
		int accessRight, 
		Type type, 
		DeclNode declNode, 
		Env env ) {
		if ( searchDeclList( ident, type.template(), Decl.PRIVATE ) != null )
			throw new Error( "Redeclared identifier " + ident );
		Decl decl = new Decl( ident, section, accessRight, type, declNode, env );
		decls.addElement( decl );
		return decl;
		}

	public Decl searchDeclList( String ident, Template template, int accessRight ) {
		//	Should really cope with multiple matches!
		for ( int i = 0; i < size(); i++ ) {
			Decl decl = elementAt( i );
			if ( decl.ident().equals( ident ) 
				&& template.matchTemplate( decl.type() )
				&&  decl.accessRight() >= accessRight )
				return decl;
			}
		return null;
		}

	public TypeList typeList() {
		TypeList typeList = new TypeList();
		for ( int i = 0; i < size(); i++ ) {
			Decl decl = elementAt( i );
			typeList.addElement( decl.type() );
			}
		return typeList;
		}

	public String toString() {
		String result = "";
		for ( int i = 0; i < size(); i++ )
			result += "%n" + elementAt( i );
		return result;
		}

	}
