package node.declNode;
import node.*;
import node.typeNode.*;
import node.declNode.declaratorNode.*;
import env.*;
import type.*;
import runEnv.*;

public class ValueParamDeclNode extends DeclStmtNode implements DeclNode {

	private TypeNode typeNode;
	private DeclaratorListNode declrList;

	public ValueParamDeclNode( TypeNode typeNode, DeclaratorListNode declrList ) {
		this.typeNode = typeNode;
		this.declrList = declrList;
		}

	public String toString() {
		return typeNode + " " + declrList + ";";
		}

	public void genEnv( int section, Env env ) {
		typeNode.genEnv( env );
		declrList.genEnv( Decl.SECT_VALUEPARAM, env );
		}

	public void genDecl() {
		Type type = typeNode.getType();
		declrList.genDecl( type );
		}

	public void checkType() {
		declrList.checkType();
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		}

	public int calcWeight() {
		weight = declrList.calcWeight();
		return weight;
		}

	public void genDeclCode() {
		declrList.genDeclCode();
		}

	public void genCode() {
		enter();
		declrList.genCode();
		exit();
		}

	}
