package node.declNode.declaratorNode;
import node.*;
import node.declNode.*;
import env.*;
import type.*;
import template.*;
import runEnv.*;
import text.*;

public abstract class DeclaratorNode extends Node implements DeclNode {

	protected String ident;
	public String ident() { return ident; }
	protected int section;
	protected Env env;
	protected Type type;
	protected Decl decl;
	public Decl decl() { return decl; }
	protected int weight;
	public int weight() { return weight; }

	public DeclaratorNode( String ident ) {
		this.ident = ident;
		}

	public void genEnv( int section, Env env ) {
		this.section = section;
		this.env = env;
		}

	public void genDecl( Type type ) {
		this.type = type;
		decl = env.searchLocal( ident, FieldTemplate.template, Decl.PRIVATE );
		if ( decl != null )
			error( "Identifier " + ident + " redeclared" );
		else
			decl = env.declare( ident, section, decl.PUBLIC, type, this );
		}

	public abstract void checkType();
	public abstract void eval( RunEnv runEnv ) throws ReturnException;
	public abstract int calcWeight();

	public void genDeclCode() {
		}

	public abstract void genCode();

	}
