package node.declNode.declaratorNode;
import node.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class UninitDeclaratorNode extends DeclaratorNode {

	public UninitDeclaratorNode( String ident ) {
		super( ident );
		}

	public String toString() {
		return ident;
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		runEnv.getData( decl ).setValue( type.defaultValue() );
		}

	public int calcWeight() {
		weight = 0;
		return weight;
		}

	public void genCode() {
		switch ( decl.section() ) {
			case Decl.SECT_GLOBAL:
			case Decl.SECT_STATIC:
			case Decl.SECT_INSTANCE:
			case Decl.SECT_LOCAL:
				if ( type instanceof RealType )
					decl.storeF( "$fzero" );
				else
					decl.store( "$zero" );
				break;
			case Decl.SECT_VARPARAM:
			case Decl.SECT_VALUEPARAM:
				break;
			case Decl.SECT_CLASS:
			default:
				error( "Invalid section of " + Decl.sectionText( decl.section() ) );
			}
		}
	}
