package node.declNode.sectionOptNode;
import node.*;
import env.*;
import runEnv.*;

public class SectionOpt1Node extends SectionOptNode {
	private int section;
	private DeclStmtListNode body;
	public SectionOpt1Node( int section, DeclStmtListNode body ) {
		this.section = section;
		this.body = body;
		}

	public String toString() {
		return Decl.sectionText( section ) + "%+%n" + body + "%-%n";
		}
 
	public void genEnv( Env env ) {
		body.genEnv( section, env );
		}

	public void genDecl() {
		body.genDecl();
		}

	public void checkType() {
		body.checkType();
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		body.eval( runEnv );
		}

	public int calcWeight() {
		weight = body.calcWeight();
		return weight;
		}

	public void genCode() {
		body.genCode();
		}
	}
