package node.exprNode;
import node.*;
import node.exprNode.variableNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class VarExprNode extends ExprNode {

	private VariableNode variable;

	public VariableNode variable() { return variable; }

	public VarExprNode( VariableNode variable ) {
		this.variable = variable;
		precedence = PREC_PRIMARY;
		}

	public String toString() {
		return "" + variable;
		}

	public void genEnv( Env env ) {
		variable.genEnv( env );
		}

	public Type checkType() {
		type = variable.checkType();
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return variable.eval( runEnv ).getValue();
		}

	public int calcWeight() {
		int varWeight = variable.calcWeight();
		weight = varWeight;
		return weight;
		}

	public void regCode( int freeReg, int freeTemp ) {
		String address = variable.addrCode( freeReg, freeTemp );
		if ( type instanceof RealType )
			loadF( ftempReg( freeReg ), address );
		else
			load( tempReg( freeReg ), address );
		}
	}
