package node.exprNode.binaryNode.relationNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class GreaterEqualNode extends RelationNode {

	public GreaterEqualNode( ExprNode left, ExprNode right ) {
		super( left, right );
		operator = ">=";
		}

	public Type checkType() {
		type = super.checkType();
		if ( operandType instanceof IntType )
			opCode = "cmplt";
		else if ( operandType instanceof RealType )
			opCode = "cmptlt";
		return type;
		}

	public RunValue eval( RunEnv runEnv ) {
		RunValue leftValue = left.eval( runEnv );
		RunValue rightValue = right.eval( runEnv );
		if ( operandType instanceof IntType )
			return new BoolValue( leftValue.intValue() >= rightValue.intValue() );
		else if ( operandType instanceof RealType )
			return new BoolValue( leftValue.realValue() >= rightValue.realValue() );
		error( "Invalid Type for >=" );
		return null;
		}

	public void boolCode( 
		int freeReg, 
		int freeTemp, 
		String trueLabel, 
		String falseLabel, 
		boolean flowIntoTrue ) {
		condCode( freeReg, freeTemp );
		if ( flowIntoTrue ) {
			if ( operandType instanceof RealType )
				instrn( "fbne", ftempReg( freeReg ), falseLabel );
			else
				instrn( "bne", tempReg( freeReg ), falseLabel );
			}
		else {
			if ( operandType instanceof RealType )
				instrn( "fbeq", ftempReg( freeReg ), trueLabel );
			else
				instrn( "beq", tempReg( freeReg ), trueLabel );
			}
		}

	}
