package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import template.*;
import runEnv.*;
import text.*;

public class IdentVariableNode extends VariableNode {

	private String ident;
	private Env env;
	private Decl decl;
	
	public IdentVariableNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public void genEnv( Env env ) {
		this.env = env;
		}

	public Type checkType() {
		decl = env.searchEnv( ident, FieldTemplate.template, Decl.PRIVATE );
		if ( decl != null ) {
			type = decl.type();
			return type;
			}
		error( "Undeclared Variable or class " + ident );
		return null;
		}

	public RunData eval( RunEnv runEnv ) {
		switch ( decl.section() ) {
			case Decl.SECT_INSTANCE:
				return runEnv.currentInstance().fields().getData( decl.offset() );
			case Decl.SECT_GLOBAL:
			case Decl.SECT_STATIC:
				return runEnv.currentStatic().fields().getData( decl.offset() );
			case Decl.SECT_CLASS:
				return null;
			case Decl.SECT_VARPARAM:
				return runEnv.currentInvocation().locals().getValue( decl.offset() ).dataValue();
			case Decl.SECT_VALUEPARAM:
			case Decl.SECT_LOCAL:
				return runEnv.currentInvocation().locals().getData( decl.offset() );
			default:
				error( "Invalid section" );
				return null;
			}
		}

	public int calcWeight() {
		weight = 1;
		return weight;
		}

	public String addrCode( int freeReg, int freeTemp ) {
		return decl.address( tempReg( freeReg ) );
		}
	}
