package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ExprStmtNode extends StmtNode {

	private ExprNode expr;
	
	public ExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return expr + ";";
		}
		
	public void genEnv( Env env ) {
		expr.genEnv( env );
		}

	public void checkType() {
		Type type = expr.checkType();
		expr = expr.castTo( VoidType.type );
		}

	public void eval( RunEnv runEnv ) {
		expr.eval( runEnv );
		}

	public int calcWeight() {
		int exprWeight = expr.calcWeight();
		weight = exprWeight;
		return weight;
		}

	public void genCode() {
		enter();
		expr.regCode( 0, 0 );
		exit();
		}
	}
