package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import text.*;

public class Println1StmtNode extends StmtNode {

	private ExprNode expr;
	
	public Println1StmtNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "println( " + expr + " );";
		}
		
	public void genEnv( Env env ) {
		expr.genEnv( env );
		}

	public void checkType() {
		Type exprType = expr.checkType();
		expr = expr.castTo( StringType.type );
		}

	public void eval( RunEnv runEnv ) {
		Print.interp().println( expr.eval( runEnv ) );
		}

	public int calcWeight() {
		int exprWeight = expr.calcWeight();
		weight = max( exprWeight, MAXREG );
		return weight;
		}

	public void genCode() {
		enter();
		expr.regCode( 0, 0 );
		move( tempReg( 0 ), "$a0" );
		bsr( "Array.toString.enter" );
		move( "$v0", "$a0" );
		bsr( "IO.println.enter" );
		exit();
		}
	}
