package node.stmtNode;
import node.*;
import node.exprNode.*;
import node.declNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ReturnStmtNode extends StmtNode {

	private Env env;
	private Decl methodDecl;
	private MethodDeclNode methodDeclNode;
	private MethodType methodType;
	private Type returnType;

	public ReturnStmtNode() {
		}

	public String toString() {
		return "return;";
		}

	public void genEnv( Env env ) {
		if ( ! ( env instanceof Env ) )
			error( "Attempting to return when not inside method" );
		this.env = ( Env ) env;
		}

	public void checkType() {
		methodDecl = env.methodDecl();
		if ( methodDecl == null )
			error( "Return not inside method" );
		methodDeclNode = ( MethodDeclNode ) methodDecl.declNode();
		methodType = ( MethodType ) methodDecl.type();
		returnType = methodType.returnType();
		if ( returnType == null )
			error( "Attempting to return when not inside method" );
		if ( ! returnType.equals( VoidType.type ) )
			error( "Must return value for non void method" );
		}
		
	public void eval( RunEnv runEnv ) throws ReturnException {
		throw new ReturnException( null );
		}

	public int calcWeight() {
		weight = 0;
		return weight;
		}

	public void genCode() {
		enter();
		br( "return" );
		exit();
		}
	}
