package node.typeNode;
import node.*;
import env.*;
import type.*;
import template.*;
import runEnv.*;

public class TypeIdentNode extends TypeNode {

	private String ident;
	private Env env;
	
	public TypeIdentNode( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return ident;
		}

	public void genEnv( Env env ) {
		this.env = env;
		}

	public Type getType() {
		Decl decl = env.searchEnv( ident, ClassTemplate.template, Decl.PRIVATE );
		if ( decl == null )
			error( "Undeclared Type " + ident );
		return decl.type().instanceType();
		}
	}
