package template;

import env.*;
import type.*;

public  class InvocationTemplate extends Template {

	private TypeList typeList;
	public TypeList typeList() { return typeList; }

	public InvocationTemplate( TypeList typeList ) {
		this.typeList = typeList;
		}

	public String toString() {
		return "InvocationTemplate( " + typeList + " )";
		}

	public boolean matchTemplate( Type type ) {
		if ( type instanceof MethodType ) {
			MethodType methodType = ( MethodType ) type;
			DeclList methodFormals = methodType.formalDecls();
			if ( typeList.size() != methodFormals.size() )
				return false;
			for ( int i = 0; i < typeList.size(); i++ ) {
				Type typeElement = typeList.elementAt( i );
				Decl decl = methodFormals.elementAt( i );
				if ( decl.section() == Decl.SECT_VALUEPARAM &&
					! decl.type().isCastable( typeElement ) )
					return false;
				if ( decl.section() == Decl.SECT_VARPARAM &&
					! decl.type().equals( typeElement ) )
					return false;
				}
			return true;
			}
		else
			return false;
		}

	}
