package type;

import type.basicType.*;
import env.*;
import template.*;

public  class InstanceType extends FieldType {

	private String ident;
	private Env env;
	public String ident() { return ident; }
	public Env env() { return env; }

	public InstanceType( String ident, Env env ) {
		this.ident = ident;
		this.env = env;
		}
	
	public boolean equals( Type type ) {
		if ( ! ( type instanceof InstanceType ) )
			return false;
		InstanceType instanceType = ( InstanceType ) type;
		return instanceType.ident().equals( ident );
		}

	public boolean isCastable( Type type ) {
		if ( type instanceof NullType )
			return true;
		if ( ! ( type instanceof InstanceType ) )
			return false;
		InstanceType instanceType = ( InstanceType ) type;
		return env.isExtension( instanceType.env() );
		}

	public String toString() {
		return "instance " + ident;
		}
	}
