package grammar;

import java.io.*;

%%

%{
	int commentNest = 0;

	int lineCount =1;
	
	boolean printed = false;
	
	void echo( String text ) {
		System.out.print( text );
		printed = true;
		}
%}

%init{
	yybegin( NORMAL );
%init}

%public
%type Void

%state NORMAL COMMENT CODESTRING

newline		=	\r|\n|\r\n
%%

<NORMAL> {
	"/*"			{
					yybegin( COMMENT );
					commentNest++;
					}
	"{:"			{ yybegin( CODESTRING ); }
	{newline}		{
					if ( printed ) {
						System.out.println();
						printed = false;
						}
					lineCount++;
					}
	:[A-Za-z0-9]+	{ }
	.				{ echo( yytext() ); }
	}
	
<COMMENT> {
	"/*"			{ commentNest++; }
	"*/"			{
					--commentNest;
					if ( commentNest == 0 )
						yybegin( NORMAL );
					}
	{newline}		{ lineCount++; }
	.				{ }
	}
	
<CODESTRING> {
	":}"			{ yybegin( NORMAL ); }
	{newline}		{ lineCount++; }
	.				{ }
	}
