package grammar;

import node.*;
import java.io.*;
import java_cup.runtime.*;

%%

%public
%type		Symbol
%char

%{
	private int lineNumber = 1;
	public int lineNumber() { return lineNumber; }
	
	public Symbol token( int tokenType ) {
		System.err.println( "Obtain token " 
			+ sym.terminal_name( tokenType ) + " \"" + yytext() + "\"" );
		return new Symbol( tokenType, yychar, 
			yychar + yytext().length(), yytext() );
		}

%}

ident		=	[A-Za-z][A-Za-z0-9]*
space		=	[\ \t]
newline		=	\r|\n|\r\n

%%

{newline}	{ lineNumber++; }
{space}		{ }

"{"			{ return token( sym.LEFTBRACE ); }
"}"			{ return token( sym.RIGHTBRACE ); }
"="			{ return token( sym.ASSIGN ); }
";"			{ return token( sym.SEMICOLON ); }
","			{ return token( sym.COMMA ); }

{ident}		{ return token( sym.IDENT ); }

.			{ return token( sym.error ); }

<<EOF>>		{ return token( sym.EOF ); }

